stages:
    - build
    - push
    - deploy
    - clean

variables:
    CONTAINER_REGISTRY: 656835574920.dkr.ecr.us-east-1.amazonaws.com
    GIT_SUBMODULE_STRATEGY: recursive

build:
    stage: build
    script:
        - aws ecr get-login-password --region us-east-1 | docker login --username AWS --password-stdin 656835574920.dkr.ecr.us-east-1.amazonaws.com
        - docker pull 656835574920.dkr.ecr.us-east-1.amazonaws.com/netlex-editor-core:latest
        - docker tag 656835574920.dkr.ecr.us-east-1.amazonaws.com/netlex-editor-core:latest netlex-editor-core:latest 
        - git submodule update --remote --merge
        - docker build --target production -t netlex-editor:latest .
    only:
        - web
        - api


push:
    stage: push
    script:
        - echo 'CI_COMMIT_REF_NAME='$CI_COMMIT_REF_NAME 'CI_COMMIT_SHORT_SHA='$CI_COMMIT_SHORT_SHA
        - NETLEX_EDITOR_IMAGE_TAG=${CI_COMMIT_REF_NAME//[^a-zA-Z0-9-]/-}-$CI_COMMIT_SHORT_SHA
        - echo 'NETLEX_EDITOR_IMAGE_TAG='$NETLEX_EDITOR_IMAGE_TAG 'TARGET_HOSTS='$TARGET_HOSTS
        - docker tag netlex-editor:latest $CONTAINER_REGISTRY/netlex-editor:$NETLEX_EDITOR_IMAGE_TAG
        - $(aws ecr get-login --no-include-email --region us-east-1)
        - docker push $CONTAINER_REGISTRY/netlex-editor:$NETLEX_EDITOR_IMAGE_TAG
        - docker image rm $CONTAINER_REGISTRY/netlex-editor:$NETLEX_EDITOR_IMAGE_TAG
    only:
        - web
        - api

deploy:
    stage: deploy
    script:
        - echo 'CI_COMMIT_REF_NAME='$CI_COMMIT_REF_NAME 'CI_COMMIT_SHORT_SHA='$CI_COMMIT_SHORT_SHA
        - NETLEX_EDITOR_IMAGE_TAG=${CI_COMMIT_REF_NAME//[^a-zA-Z0-9-]/-}-$CI_COMMIT_SHORT_SHA
        - echo 'NETLEX_EDITOR_IMAGE_TAG='$NETLEX_EDITOR_IMAGE_TAG 'TARGET_HOSTS='$TARGET_HOSTS
        - if [ -z "$TARGET_HOSTS" ] && [ "$CI_COMMIT_REF_NAME" == "master" ]; then TARGET_HOSTS=production; fi
        - if [ -z "$TARGET_HOSTS" ] && [ "$CI_COMMIT_REF_NAME" != "master" ]; then TARGET_HOSTS=staging; fi
        - echo 'TARGET_HOSTS='$TARGET_HOSTS
        - if [ "$TARGET_HOSTS" == "production" ] && [ "$CI_COMMIT_REF_NAME" != "master" ]; then TARGET_HOSTS=none; exit 1; fi
        - ansible-playbook ~/netlex-ansible/swarm-deploy-netlex-editor.yml -e "target_hosts=$TARGET_HOSTS netlex_editor_image_tag=$NETLEX_EDITOR_IMAGE_TAG"
    only:
        - web
        - api

clean:
    stage: clean
    script:
        - docker image rm netlex-editor
        - docker image rm netlex-editor-core
    only:
        - web
        - api
